/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cosmodas.EntCosmos;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * @author obper
 */
@Entity
@Table(name = "cuentas_bancos")
@XmlRootElement
@NamedQueries({
        @NamedQuery(name = "CuentasBancos.findAll", query = "SELECT c FROM CuentasBancos c"),
        @NamedQuery(name = "CuentasBancos.findByCodigoBanco", query = "SELECT c FROM CuentasBancos c WHERE c.codigoBanco = :codigoBanco"),
        @NamedQuery(name = "CuentasBancos.findByCorrelativo", query = "SELECT c FROM CuentasBancos c WHERE c.correlativo = :correlativo"),
        @NamedQuery(name = "CuentasBancos.findByTipoCuenta", query = "SELECT c FROM CuentasBancos c WHERE c.tipoCuenta = :tipoCuenta"),
        @NamedQuery(name = "CuentasBancos.findByDescripcionCuenta", query = "SELECT c FROM CuentasBancos c WHERE c.descripcionCuenta = :descripcionCuenta"),
        @NamedQuery(name = "CuentasBancos.findByNumeroCuenta", query = "SELECT c FROM CuentasBancos c WHERE c.numeroCuenta = :numeroCuenta"),
        @NamedQuery(name = "CuentasBancos.findByInicioTalonario", query = "SELECT c FROM CuentasBancos c WHERE c.inicioTalonario = :inicioTalonario"),
        @NamedQuery(name = "CuentasBancos.findByFinTalonario", query = "SELECT c FROM CuentasBancos c WHERE c.finTalonario = :finTalonario"),
        @NamedQuery(name = "CuentasBancos.findByNumeracionSiguiente", query = "SELECT c FROM CuentasBancos c WHERE c.numeracionSiguiente = :numeracionSiguiente"),
        @NamedQuery(name = "CuentasBancos.findByCuentaContable", query = "SELECT c FROM CuentasBancos c WHERE c.cuentaContable = :cuentaContable")})
public class CuentasBancos implements Serializable {
    private static final long serialVersionUID = 1L;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 2)
    @Column(name = "codigo_banco")
    private String codigoBanco;
    @Id
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 2)
    @Column(name = "correlativo")
    private String correlativo;
    @Basic(optional = false)
    @NotNull
    @Column(name = "tipo_cuenta")
    private Character tipoCuenta;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 30)
    @Column(name = "descripcion_cuenta")
    private String descripcionCuenta;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 20)
    @Column(name = "numero_cuenta")
    private String numeroCuenta;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 9)
    @Column(name = "inicio_talonario")
    private String inicioTalonario;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 9)
    @Column(name = "fin_talonario")
    private String finTalonario;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 9)
    @Column(name = "numeracion_siguiente")
    private String numeracionSiguiente;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 14)
    @Column(name = "cuenta_contable")
    private String cuentaContable;

    public CuentasBancos() {
    }

    public CuentasBancos(String correlativo) {
        this.correlativo = correlativo;
    }

    public CuentasBancos(String correlativo, String codigoBanco, Character tipoCuenta, String descripcionCuenta, String numeroCuenta, String inicioTalonario, String finTalonario, String numeracionSiguiente, String cuentaContable) {
        this.correlativo = correlativo;
        this.codigoBanco = codigoBanco;
        this.tipoCuenta = tipoCuenta;
        this.descripcionCuenta = descripcionCuenta;
        this.numeroCuenta = numeroCuenta;
        this.inicioTalonario = inicioTalonario;
        this.finTalonario = finTalonario;
        this.numeracionSiguiente = numeracionSiguiente;
        this.cuentaContable = cuentaContable;
    }

    public String getCodigoBanco() {
        return codigoBanco;
    }

    public void setCodigoBanco(String codigoBanco) {
        this.codigoBanco = codigoBanco;
    }

    public String getCorrelativo() {
        return correlativo;
    }

    public void setCorrelativo(String correlativo) {
        this.correlativo = correlativo;
    }

    public Character getTipoCuenta() {
        return tipoCuenta;
    }

    public void setTipoCuenta(Character tipoCuenta) {
        this.tipoCuenta = tipoCuenta;
    }

    public String getDescripcionCuenta() {
        return descripcionCuenta;
    }

    public void setDescripcionCuenta(String descripcionCuenta) {
        this.descripcionCuenta = descripcionCuenta;
    }

    public String getNumeroCuenta() {
        return numeroCuenta;
    }

    public void setNumeroCuenta(String numeroCuenta) {
        this.numeroCuenta = numeroCuenta;
    }

    public String getInicioTalonario() {
        return inicioTalonario;
    }

    public void setInicioTalonario(String inicioTalonario) {
        this.inicioTalonario = inicioTalonario;
    }

    public String getFinTalonario() {
        return finTalonario;
    }

    public void setFinTalonario(String finTalonario) {
        this.finTalonario = finTalonario;
    }

    public String getNumeracionSiguiente() {
        return numeracionSiguiente;
    }

    public void setNumeracionSiguiente(String numeracionSiguiente) {
        this.numeracionSiguiente = numeracionSiguiente;
    }

    public String getCuentaContable() {
        return cuentaContable;
    }

    public void setCuentaContable(String cuentaContable) {
        this.cuentaContable = cuentaContable;
    }

//    @Override
//    public int hashCode() {
//        int hash = 0;
//        hash += (correlativo != null ? correlativo.hashCode() : 0);
//        return hash;
//    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof CuentasBancos)) {
            return false;
        }
        CuentasBancos other = (CuentasBancos) object;
        if ((this.correlativo == null && other.correlativo != null) || (this.correlativo != null && !this.correlativo.equals(other.correlativo))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.cosmodas.dbcon.CuentasBancos[ correlativo=" + correlativo + " ]";
    }

}
